## Preparing for development

1. Make sure you have [Carthage](https://github.com/Carthage/Carthage) installed. We use it to pull the RxSwiftExt dependency for development.
2. Check out this repository.
3. Do a `carthage update --platform ios --no-use-binaries`
4. Open `RxSwiftExt.xcworkspace` and start hacking!

## About contributions

There are multiple ways you can contribute to this project.

The easiest way to contribute is to report possible bugs, request features, [discuss ideas](https://github.com/RxSwiftCommunity/RxSwiftExt/issues) and share excitement about this project. We use [issues](https://github.com/RxSwiftCommunity/RxSwiftExt/issues) to discuss new operators for inclusion in the project.

You can also make pull requests. Other than bug fixes, please make sure you discuss your contribution in Issues first.

## Submitting a Pull Request

When submitting new code, please make sure that it is backed by tests. When submitting code for a new operator, please make sure that:

- Your code documents what the operator does (see other operators for examples).
- You provide tests for your new operator.
- You provide a demo playground page, and add a reference to this page in the playground index.
- You add documentation of the operator in this repo's `README.md` file.

**Note**: Base your custom operators only on RxSwift Core operators. Do not use existing RxSwiftExt operators to implement your own operator, unless it's an absolute necessity.

## Developer's Certificate of Origin 1.1

By making a contribution to this project, I certify that:

- (a) The contribution was created in whole or in part by me and I
      have the right to submit it under the open source license
      indicated in the file; or

- (b) The contribution is based upon previous work that, to the best
      of my knowledge, is covered under an appropriate open source
      license and I have the right under that license to submit that
      work with modifications, whether created in whole or in part
      by me, under the same open source license (unless I am
      permitted to submit under a different license), as indicated
      in the file; or

- (c) The contribution was provided directly to me by some other
      person who certified (a), (b) or (c) and I have not modified
      it.

- (d) I understand and agree that this project and the contribution
      are public and that a record of the contribution (including all
      personal information I submit with it, including my sign-off) is
      maintained indefinitely and may be redistributed consistent with
      this project or the open source license(s) involved.

*Wording of statement copied from [elinux.org](http://elinux.org/Developer_Certificate_Of_Origin)*
